package smash.appointment.parse;

public class SubjectSqlExporter {

	public String toSql(Subject subject) {
		StringBuilder result = new StringBuilder("");

		result.append("insert into web_subject (");
		result.append("sex, ");
		result.append("last_name, ");
		result.append("first_name, ");
		result.append("comments,");
		result.append("address,");
		result.append("postal_code, ");
		result.append("city, ");
		result.append("country, ");
		result.append("phone_number,");
		result.append("phone_number_2,");
		result.append("phone_number_3,");
		result.append("email,");
		result.append("year_of_diagnosis,");
		result.append("diagnosis,");
		result.append("referral,");
		result.append("date_added,");
		result.append("nd_number,");
		result.append("mpower_id,");
		result.append("screening_number,");
		result.append("default_appointment_location,");
		result.append("type,");
		result.append("dead,");
		result.append("resigned,");
		result.append("date_born) ");

		result.append("values (");
		result.append(getStringVal(subject.getSex()) + ",");
		result.append(getStringVal(subject.getSurname()) + ",");
		result.append(getStringVal(subject.getName()) + ",");
		result.append(getStringVal(subject.getRemarks()) + ",");
		result.append(getStringVal(subject.getAddress()) + ",");
		result.append(getStringVal(subject.getZipCode()) + ",");
		result.append(getStringVal(subject.getCity()) + ",");
		result.append(getStringVal(subject.getCountry()) + ",");
		result.append(getStringVal(subject.getPhone1()) + ",");
		result.append(getStringVal(subject.getPhone2()) + ",");
		result.append(getStringVal(subject.getPhone3()) + ",");
		result.append(getStringVal(subject.getMail()) + ",");
		result.append(getIntVal(subject.getDiagnosisYear()) + ",");
		result.append(getStringVal(subject.getDiagnosis()) + ",");
		result.append(getStringVal(subject.getReferal()) + ",");
		result.append(getDateVal(subject.getAddDate()) + ",");
		result.append(getStringVal(subject.getNdNumber()) + ",");
		result.append(getStringVal(subject.getmPowerId()) + ",");
		result.append(getStringVal(subject.getScreeningNumber()) + ",");
		result.append(getStringVal(subject.getToBeSeenAt()) + ",");
		result.append(getStringVal(subject.getType().toString().substring(0, 1)) + ",");
		result.append(subject.isDead() + ",");
		result.append(subject.isResigned() + ",");
		result.append(getDateVal(subject.getBirthDate()));
		result.append(");");

		return result.toString();
	}

	private String getIntVal(String diagnosisYear) {
		if (diagnosisYear == null || diagnosisYear.trim().isEmpty()) {
			return "0";
		} else {
			return diagnosisYear;
		}
	}

	private String getStringVal(String arg) {
		if (arg == null) {
			return "null";
		} else if (arg.isEmpty()) {
			return "''";
		} else {
			return "'" + arg + "'";
		}
	}
	private String getDateVal(String arg) {
		if (arg == null) {
			return "null";
		} else if (arg.isEmpty()) {
			return "null";
		} else {
			return "'" + arg + "'";
		}
	}
}
